--
-- PostgreSQL database dump
--

SET client_encoding = 'UTF8';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: config; Type: TABLE; Schema: public; Owner: gsphonebook; Tablespace: 
--

CREATE TABLE config (
    uid integer,
    "key" text NOT NULL,
    value text
);


ALTER TABLE public.config OWNER TO gsphonebook;

--
-- Name: group_user; Type: TABLE; Schema: public; Owner: gsphonebook; Tablespace: 
--

CREATE TABLE group_user (
    gid integer,
    uid integer
);


ALTER TABLE public.group_user OWNER TO gsphonebook;

--
-- Name: groups; Type: TABLE; Schema: public; Owner: gsphonebook; Tablespace: 
--

CREATE TABLE groups (
    id serial NOT NULL,
    groupname text
);


ALTER TABLE public.groups OWNER TO gsphonebook;

--
-- Name: phonebook; Type: TABLE; Schema: public; Owner: gsphonebook; Tablespace: 
--

CREATE TABLE phonebook (
    id serial NOT NULL,
    lastname text,
    firstname text,
    info text,
    phonenumber text,
    accountindex smallint,
    gid integer
);


ALTER TABLE public.phonebook OWNER TO gsphonebook;

--
-- Name: users; Type: TABLE; Schema: public; Owner: gsphonebook; Tablespace: 
--

CREATE TABLE users (
    id serial NOT NULL,
    username text,
    ext text,
    gshostname text,
    "password" text,
    "admin" boolean,
    phone text,
    callerid text
);


ALTER TABLE public.users OWNER TO gsphonebook;

--
-- Name: groups_pkey; Type: CONSTRAINT; Schema: public; Owner: gsphonebook; Tablespace: 
--

ALTER TABLE ONLY groups
    ADD CONSTRAINT groups_pkey PRIMARY KEY (id);


--
-- Name: phonebook_pkey; Type: CONSTRAINT; Schema: public; Owner: gsphonebook; Tablespace: 
--

ALTER TABLE ONLY phonebook
    ADD CONSTRAINT phonebook_pkey PRIMARY KEY (id);


--
-- Name: users_pkey; Type: CONSTRAINT; Schema: public; Owner: gsphonebook; Tablespace: 
--

ALTER TABLE ONLY users
    ADD CONSTRAINT users_pkey PRIMARY KEY (id);


--
-- Name: config_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gsphonebook
--

ALTER TABLE ONLY config
    ADD CONSTRAINT config_uid_fkey FOREIGN KEY (uid) REFERENCES users(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: group_user_gid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gsphonebook
--

ALTER TABLE ONLY group_user
    ADD CONSTRAINT group_user_gid_fkey FOREIGN KEY (gid) REFERENCES groups(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: group_user_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gsphonebook
--

ALTER TABLE ONLY group_user
    ADD CONSTRAINT group_user_uid_fkey FOREIGN KEY (uid) REFERENCES users(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: phonebook_gid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gsphonebook
--

ALTER TABLE ONLY phonebook
    ADD CONSTRAINT phonebook_gid_fkey FOREIGN KEY (gid) REFERENCES groups(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- Name: config; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE config FROM PUBLIC;
REVOKE ALL ON TABLE config FROM gsphonebook;
GRANT ALL ON TABLE config TO gsphonebook;


--
-- Name: group_user; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE group_user FROM PUBLIC;
REVOKE ALL ON TABLE group_user FROM gsphonebook;
GRANT ALL ON TABLE group_user TO gsphonebook;


--
-- Name: groups; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE groups FROM PUBLIC;
REVOKE ALL ON TABLE groups FROM gsphonebook;
GRANT ALL ON TABLE groups TO gsphonebook;


--
-- Name: groups_id_seq; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE groups_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE groups_id_seq FROM gsphonebook;
GRANT ALL ON TABLE groups_id_seq TO gsphonebook;


--
-- Name: phonebook; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE phonebook FROM PUBLIC;
REVOKE ALL ON TABLE phonebook FROM gsphonebook;
GRANT ALL ON TABLE phonebook TO gsphonebook;


--
-- Name: phonebook_id_seq; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE phonebook_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE phonebook_id_seq FROM gsphonebook;
GRANT ALL ON TABLE phonebook_id_seq TO gsphonebook;


--
-- Name: users; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE users FROM PUBLIC;
REVOKE ALL ON TABLE users FROM gsphonebook;
GRANT ALL ON TABLE users TO gsphonebook;


--
-- Name: users_id_seq; Type: ACL; Schema: public; Owner: gsphonebook
--

REVOKE ALL ON TABLE users_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE users_id_seq FROM gsphonebook;
GRANT ALL ON TABLE users_id_seq TO gsphonebook;


--
-- PostgreSQL database dump complete
--

--
-- Setup admin account and  group
--

INSERT INTO users (username, password) VALUES ('admin', 'admin');
INSERT INTO groups (groupname) VALUES ('admin');
INSERT INTO group_user (gid, uid) VALUES (1, 1);
